module Origen
  ENCODINGS = {
    utf8: {
      inverted_exclamation_mark:                  "\u00A1",
      cent_sign:                                  "\u00A2",
      pound_sign:                                 "\u00A3",
      currency_sign:                              "\u00A4",
      yen_sign:                                   "\u00A5",
      broken_bar:                                 "\u00A6",
      section_sign:                               "\u00A7",
      diaeresis:                                  "\u00A8",
      copyright_sign:                             "\u00A9",
      feminine_ordinal_indicator:                 "\u00AA",
      left_pointing_double_angle_quotation_mark:  "\u00AB",
      not_sign:                                   "\u00AC",
      soft_hyphen:                                "\u00AD",
      registered_sign:                            "\u00AE ",
      macron:                                     "\u00AF",
      degree_sign:                                "\u00B0",
      plus_minus_sign:                            "\u00B1",
      superscript_two:                            "\u00B2",
      superscript_three:                          "\u00B3",
      acute_accent:                               "\u00B4",
      micro_sign:                                 "\u00B5",
      pilcrow_sign:                               "\u00B6",
      middle_dot:                                 "\u00B7",
      cedilla:                                    "\u00B8",
      superscript_one:                            "\u00B9",
      masculine_ordinal_indicator:                "\u00BA",
      right_pointing_double_angle_quotation_mark: "\u00BB",
      vulgar_fraction_one_quarter:                "\u00BC",
      vulgar_fraction_one_half:                   "\u00BD",
      vulgar_fraction_three_quarters:             "\u00BE",
      inverted_question_mark:                     "\u00BF",
      latin_capital_letter_a_with_grave:          "\u00C0",
      latin_capital_letter_a_with_acute:          "\u00C1",
      latin_capital_letter_a_with_circumflex:     "\u00C2",
      latin_capital_letter_a_with_tilde:          "\u00C3",
      latin_capital_letter_a_with_diaeresis:      "\u00C4",
      latin_capital_letter_a_with_ring_above:     "\u00C5",
      latin_capital_letter_ae:                    "\u00C6",
      latin_capital_letter_c_with_cedilla:        "\u00C7",
      latin_capital_letter_e_with_grave:          "\u00C8",
      latin_capital_letter_e_with_acute:          "\u00C9",
      latin_capital_letter_e_with_circumflex:     "\u00CA",
      latin_capital_letter_e_with_diaeresis:      "\u00CB",
      latin_capital_letter_i_with_grave:          "\u00CC",
      latin_capital_letter_i_with_acute:          "\u00CD",
      latin_capital_letter_i_with_circumflex:     "\u00CE",
      latin_capital_letter_i_with_diaeresis:      "\u00CF",
      latin_capital_letter_eth:                   "\u00D0",
      latin_capital_letter_n_with_tilde:          "\u00D1",
      latin_capital_letter_o_with_grave:          "\u00D2",
      latin_capital_letter_o_with_acute:          "\u00D3",
      latin_capital_letter_o_with_circumflex:     "\u00D4",
      latin_capital_letter_o_with_tilde:          "\u00D5",
      latin_capital_letter_o_with_diaeresis:      "\u00D6",
      multiplication_sign:                        "\u00D7",
      latin_capital_letter_o_with_stroke:         "\u00D8",
      latin_capital_letter_u_with_grave:          "\u00D9",
      latin_capital_letter_u_with_acute:          "\u00DA",
      latin_capital_letter_u_with_circumflex:     "\u00DB",
      latin_capital_letter_u_with_diaeresis:      "\u00DC",
      latin_capital_letter_y_with_acute:          "\u00DD",
      latin_capital_letter_thorn:                 "\u00DE",
      latin_small_letter_sharp_s:                 "\u00DF",
      latin_small_letter_a_with_grave:            "\u00E0",
      latin_small_letter_a_with_acute:            "\u00E1",
      latin_small_letter_a_with_circumflex:       "\u00E2",
      latin_small_letter_a_with_tilde:            "\u00E3",
      latin_small_letter_a_with_diaeresis:        "\u00E4",
      latin_small_letter_a_with_ring_above:       "\u00E5",
      latin_small_letter_ae:                      "\u00E6",
      latin_small_letter_c_with_cedilla:          "\u00E7",
      latin_small_letter_e_with_grave:            "\u00E8",
      latin_small_letter_e_with_acute:            "\u00E9",
      latin_small_letter_e_with_circumflex:       "\u00EA",
      latin_small_letter_e_with_diaeresis:        "\u00EB",
      latin_small_letter_i_with_grave:            "\u00EC",
      latin_small_letter_i_with_acute:            "\u00ED",
      latin_small_letter_i_with_circumflex:       "\u00EE",
      latin_small_letter_i_with_diaeresis:        "\u00EF",
      latin_small_letter_eth:                     "\u00F0",
      latin_small_letter_n_with_tilde:            "\u00F1",
      latin_small_letter_o_with_grave:            "\u00F2",
      latin_small_letter_o_with_acute:            "\u00F3",
      latin_small_letter_o_with_circumflex:       "\u00F4",
      latin_small_letter_o_with_tilde:            "\u00F5",
      latin_small_letter_o_with_diaeresis:        "\u00F6",
      division_sign:                              "\u00F7",
      latin_small_letter_o_with_stroke:           "\u00F8",
      latin_small_letter_u_with_grave:            "\u00F9",
      latin_small_letter_u_with_acute:            "\u00FA",
      latin_small_letter_u_with_circumflex:       "\u00FB",
      latin_small_letter_u_with_diaeresis:        "\u00FC",
      latin_small_letter_y_with_acute:            "\u00FD",
      latin_small_letter_thorn:                   "\u00FE",
      latin_small_letter_y_with_diaeresis:        "\u00FF",
      ohm_sign:                                   "\u03A9"
    }
  }
end
